(define-module (ui sshd keys ajax)
    :use-module (alterator woo)
    :use-module (alterator ajax)
    :use-module (alterator str)
    :use-module (alterator effect)
    :use-module (alterator algo)
    :export (init))

(define (return)
    (form-replace "/sshd"))

(define (ui-init)
    (let* ((data (woo-list "/sshd/users"))
	(cur_name (and (pair? data) (woo-get-option (car data) 'name))))
	(form-update-enum "userlist" data) 
	(and cur_name (form-update-value "userlist" cur_name) ))
    (let* ((data (woo-list "/sshd/keyfiles"))
	(cur_name (and (pair? data) (woo-get-option (car data) 'name))))
	(form-update-enum "keyfiles" data) 
	(and cur_name (form-update-value "keyfiles" cur_name) ))
    (read_keys (form-value "keyfiles"))
    (update-effect))

(define (read_keys . data)
  (let ((file (if (pair? data) (car data) (form-value "keyfiles"))))
    (form-update-enum "keylist" 
      (woo-list "/sshd/keys" 'file file
       'language (form-value "language")))))

(define (delete_selected)
    (catch/message
	(lambda()
    	    (apply woo-delete "/sshd/keylist"
    		'language (form-value "language")
    		'file (form-value "keyfiles")
                (form-value-list '("keylist")))
    (let* ((data (woo-list "/sshd/keyfiles"))
	(cur_name (and (pair? data) (woo-get-option (car data) 'name))))
	(form-update-enum "keyfiles" data) 
	(and cur_name (form-update-value "keyfiles" cur_name)))
    (read_keys (form-value "keyfiles")))))

(define (add_key)
    (call-with-form-file
      "key_file"
      (lambda(path)
        (catch/message
          (lambda()
            (woo-write "/sshd/key"
        	'file (form-value "userlist")
                'language (form-value "language")
                'key_file path)))))
    (let* ((data (woo-list "/sshd/keyfiles"))
	(cur_name (and (pair? data) (woo-get-option (car data) 'name))))
	(form-update-enum "keyfiles" data) 
	(and cur_name (form-update-value "keyfiles" cur_name)))
    (form-update-value "keyfiles" (form-value "userlist"))
    (read_keys))

(define (show_keyfiles)
    (form-update-value "keyfiles" (form-value "userlist"))
    (read_keys))

(define (init)
    (effect-disable "key_file" "userlist" "none")
    (init-effect)
    (ui-init)
    (form-bind "ret_btn" "click" return)
    (form-bind-upload "upload_key_btn" "click" "key_file" add_key)
    (form-bind "del_selected_btn" "click" delete_selected)
    (form-bind "keyfiles" "change" read_keys)
    (form-bind "userlist" "change" show_keyfiles)
    
)
